{ Mugurel Ionut Andreica - Bucuresti }

{$S-,I-,R-,Q-}
{$M 30000,0,655360}

Program Camere_luminate;

type plist=^list;
     list=record
          cod:integer;
          poz:byte;
          urm:plist;
          end;
     boolvect=array[0..2048,1..11] of boolean;
     predmovvect=array[0..2048,1..11] of char;
     predcamvect=array[0..2048,1..11] of byte;

const bit:array[1..11] of integer=
                       (
                       1,
                       2,
                       4,
                       8,
                       16,
                       32,
                       64,
                       128,
                       256,
                       512,
                       1024
                       );

var fin,fout:text;
    mask,i,j,k,m,n,dest,ini,act,next,p,nm:integer;
    nrvec,nra,nrs:array[1..11] of byte;
    lvec,la,ls:array[1..11,1..11] of byte;
    nmin:array[0..2048,1..11] of integer;
    incoada:^boolvect;
    predmov:^predmovvect;
    predcam:^predcamvect;
    cst,aux,cfin:plist;

procedure print(conf:integer;cam:byte);
var s:byte;
begin
case predmov^[conf,cam] of
'a':begin
    s:=predcam^[conf,cam];
    print(conf-bit[s],cam);
    writeln(fout,'a ',s);
    end;
's':begin
    s:=predcam^[conf,cam];
    print(conf+bit[s],cam);
    writeln(fout,'s ',s);
    end;
'm':begin
    print(conf,predcam^[conf,cam]);
    writeln(fout,'m ',cam);
    end;
end;
end;

begin
assign(fin,'vila.in');
reset(fin);
readln(fin,n);

for i:=1 to n do
  begin
    read(fin,nrvec[i]);
    for j:=1 to nrvec[i] do
      read(fin,lvec[i,j]);
    readln(fin);
  end;

for i:=1 to n do
  begin
    read(fin,nra[i]);
    for j:=1 to nra[i] do
      read(fin,la[i,j]);
    readln(fin);
  end;

for i:=1 to n do
  begin
    read(fin,nrs[i]);
    for j:=1 to nrs[i] do
      read(fin,ls[i,j]);
    readln(fin);
  end;

close(fin);

mask:=0;
for i:=1 to n do
  mask:=mask or bit[i];

new(predmov);
fillchar(predmov^,sizeof(predmov^),0);
new(predcam);
fillchar(predcam^,sizeof(predcam^),0);
new(incoada);
fillchar(incoada^,sizeof(incoada^),false);

fillchar(nmin,sizeof(nmin),127);

ini:=bit[1];
nmin[ini,1]:=0;
predmov^[ini,1]:='x';

dest:=bit[n];

new(cst);
cst^.cod:=ini;
cst^.poz:=1;
cst^.urm:=nil;
incoada^[ini,1]:=true;
cfin:=cst;

while (cst<>nil) do
  begin
    act:=cst^.cod;
    p:=cst^.poz;

    nm:=nmin[act,p];

    { - Miscare - }
    for i:=1 to nrvec[p] do
      if (act and bit[lvec[p,i]]>0) and
         (nmin[act,lvec[p,i]]>nm+1) then
        begin
          nmin[act,lvec[p,i]]:=nm+1;
          predmov^[act,lvec[p,i]]:='m';
          predcam^[act,lvec[p,i]]:=p;

          if (not incoada^[act,lvec[p,i]]) then
            begin
              incoada^[act,lvec[p,i]]:=true;
              new(aux);
              aux^.cod:=act;
              aux^.poz:=lvec[p,i];
              aux^.urm:=nil;
              cfin^.urm:=aux;
              cfin:=aux;
            end;
        end;

    { - Aprinde lumina - }
    for i:=1 to nra[p] do
      begin
        next:=act or bit[la[p,i]];

        if (act and bit[la[p,i]]=0) and
           (nmin[next,p]>nm+1) then
          begin
            nmin[next,p]:=nm+1;
            predmov^[next,p]:='a';
            predcam^[next,p]:=la[p,i];

            if (not incoada^[next,p]) then
              begin
                incoada^[next,p]:=true;
                new(aux);
                aux^.cod:=next;
                aux^.poz:=p;
                aux^.urm:=nil;
                cfin^.urm:=aux;
                cfin:=aux;
              end;
          end;


       end;

    { - Stinge lumina - }
    for i:=1 to nrs[p] do
      begin
        next:=mask-bit[ls[p,i]];
        next:=act and next;

        if (act and bit[ls[p,i]]>0) and
           (nmin[next,p]>nm+1) then
          begin
            nmin[next,p]:=nm+1;
            predmov^[next,p]:='s';
            predcam^[next,p]:=ls[p,i];

            if (not incoada^[next,p]) then
              begin
                incoada^[next,p]:=true;
                new(aux);
                aux^.cod:=next;
                aux^.poz:=p;
                aux^.urm:=nil;
                cfin^.urm:=aux;
                cfin:=aux;
              end;
          end;
        end;


    incoada^[act,p]:=false;
    aux:=cst;
    cst:=cst^.urm;
    dispose(aux);
  end;

assign(fout,'vila.out');
rewrite(fout);

if (nmin[dest,n]=32639) then
  writeln(fout,'Nu exista solutie')
else
  begin
    writeln(fout,nmin[dest,n]);
    print(dest,n);
  end;

close(fout);

end.