#include <stdio.h>

#define NMax	100

int i,j,n,min,cupl=0,cost;
int nr0[NMax+1],lin[NMax+1],col[NMax+1];
unsigned char a[NMax+1][NMax+1],b[NMax+1][NMax+1],marc[NMax+1][NMax+1];

void load(void)
{
	FILE *fp=fopen("medias.in","rt");
	fscanf(fp,"%d",&n);
	for(i=1;i<=n;i++) for(j=1;j<=n;j++)	{ fscanf(fp,"%d",&a[i][j]); b[i][j]=a[i][j]; }
	fclose(fp);
	for(i=1;i<=n;i++)
	{
		for(min=255,j=1;j<=n;j++) if (a[i][j]<min) min=a[i][j];
		for(j=1;j<=n;j++) a[i][j]-=min;
		for(min=255,j=1;j<=n;j++) if (a[j][i]<min) min=a[j][i];
		for(j=1;j<=n;j++) a[j][i]-=min;
	}
}

void marchez(void)
{
	int k,p;

	cupl=0;
	for(i=1;i<=n;i++) nr0[i]=0;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++) marc[i][j]=0;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			if (a[i][j]==0) nr0[i]++;
	for(min=255,i=1,k=0;i<=n;i++)
		if ((nr0[i]<min)&&(nr0[i]>0)) { min=nr0[i]; k=i; }
	while (k)
	{
		for(j=1;j<=n;j++)
			if ((a[k][j]==0)&&(marc[k][j]==0)) p=j;
		marc[k][p]=1; cupl++; nr0[k]=255;
		for(i=1;i<=n;i++) if (i!=k) if (a[i][p]==0) { marc[i][p]=2; if (nr0[i]<255) nr0[i]--; }
		for(j=1;j<=n;j++) if (j!=p) if (a[k][j]==0) marc[k][j]=2;
		for(min=255,i=1,k=0;i<=n;i++)
			if ((nr0[i]<min)&&(nr0[i]>0)) { min=nr0[i]; k=i; }
	}
}

void elimin(void)
{
	int modif,nrz;

	for(i=1;i<=n;i++) { lin[i]=0; col[i]=0; }
	for(i=1;i<=n;i++)
	  {
		for(nrz=0,j=1;j<=n;j++)
			if ((a[i][j]==0)&&(marc[i][j]==1)) nrz++;
		if (nrz==0) lin[i]=1;
	  }
	modif=1;
	while (modif)
	{
		// coloane cu 0 barat in linii marcate
		modif=0;
		for(i=1;i<=n;i++)
			if (lin[i])
				for(j=1;j<=n;j++)
					if ((a[i][j]==0)&&(marc[i][j]==2)&&(!col[j]))
						{ col[j]=1; modif=1; }
		// linii cu 0 incadrat in coloane marcate
		for(j=1;j<=n;j++)
			if (col[j])
				for(i=1;i<=n;i++)
					if ((a[i][j]==0)&&(marc[i][j]==1)&&(!lin[i]))
						{ lin[i]=1; modif=1; }
	}
	// reactualizam
	for (min=255,i=1;i<=n;i++)
		if (lin[i]) for(j=1;j<=n;j++) if (!col[j]) if (a[i][j]<min) min=a[i][j];
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			{
				if ((!lin[i])&&(col[j])) a[i][j]+=min;
				else if ((lin[i])&&(!col[j])) a[i][j]-=min;
			}
}

void write(void)
{
	FILE *fp=fopen("medias.out","wt");
	for(cost=0,i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			if ((a[i][j]==0)&&(marc[i][j]==1))
				{ fprintf(fp,"%d %d %d\n",i,j,b[i][j]); cost+=(int)b[i][j]; }
	fprintf(fp,"%d\n",cost);
	fclose(fp);
}

void main(void)
{
	load();
	while (cupl<n) { marchez(); if (cupl<n) elimin(); }
	write();
}