{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 30000,0,655360}

Program Telescaun;

const infinit:extended=1.0E20;
      eps:extended=1E-6;

var fin,fout:text;
    ldir1,ldir2,pma,pmi,i,j,k,m,n,sseg1,sseg2,nmax,nmin,vmax,vmin:integer;
    lma,cma,lmi,cmi,lastl,lastc,destl,destc:integer;
    a:array[1..100,1..100] of integer;
    maxl,maxc,minl,minc:array[1..10000] of byte;
    dmin,dact:extended;
    xint,yint,xi,yi,x,y,xf,yf,a1,b1,c1,a2,b2,c2:extended;
    xs1,ys1,xs2,ys2:array[1..4] of extended;
    solutie:boolean;

procedure sol0;
begin
assign(fout,'COTE.OUT');
rewrite(fout);
writeln(fout,'0.00');
writeln(fout,'1 1 1 1');
close(fout);
halt(0);
end;

procedure printsol(posy:integer);
begin
assign(fout,'COTE.OUT');
rewrite(fout);
if posy=1 then
  begin
    writeln(fout,dmin:0:2);
    writeln(fout,lma,' ',cma,' ',lmi,' ',cmi);
  end
else
  writeln(fout,'IMPOSIBIL');
close(fout);
halt(0);
end;

begin
assign(fin,'COTE.IN');
reset(fin);
readln(fin,m,n);

vmax:=-1;
vmin:=7777;

for i:=1 to m do
  begin
    for j:=1 to n do
      begin
        read(fin,a[i,j]);
        if (a[i,j]>vmax) then vmax:=a[i,j];
        if (a[i,j]<vmin) then vmin:=a[i,j];
      end;
  end;

if (vmin=vmax) then sol0;

{ - Vector de maxime si minime - }

nmin:=0; nmax:=0;

for i:=1 to m do
  for j:=1 to n do
    if (a[i,j]=vmax) then
      begin
        inc(nmax);
        maxl[nmax]:=i; maxc[nmax]:=j;
      end
    else
      if (a[i,j]=vmin) then
        begin
          inc(nmin);
          minl[nmin]:=i; minc[nmin]:=j;
        end;

{ - END Vector - }

dmin:=infinit;

for pma:=1 to nmax do
  for pmi:=1 to nmin do
    begin
      dact:=sqrt((maxl[pma]-minl[pmi])*(maxl[pma]-minl[pmi])+
                 (maxc[pma]-minc[pmi])*(maxc[pma]-minc[pmi]));
      if (dact<dmin) then
        begin
          solutie:=true;
          i:=maxl[pma]; j:=maxc[pma];
          destl:=minl[pmi]; destc:=minc[pmi];
          ldir1:=0; ldir2:=0;

          x:=j-0.5; y:=m-i+0.5;
          xf:=destc-0.5; yf:=m-destl+0.5;

          a1:=y-yf;
          b1:=xf-x;
          c1:=x*yf-xf*y;

          while ((i<>destl) or (j<>destc)) and (solutie) do
            begin

              xs1[1]:=j-1;   xs2[1]:=j-1;
              ys1[1]:=m-i;   ys2[1]:=m-i+1;

              xs1[2]:=j;     xs2[2]:=j;
              ys1[2]:=m-i;   ys2[2]:=m-i+1;

              xs1[3]:=j-1;   xs2[3]:=j;
              ys1[3]:=m-i;   ys2[3]:=m-i;

              xs1[4]:=j-1;   xs2[4]:=j;
              ys1[4]:=m-i+1; ys2[4]:=m-i+1;

              sseg1:=0; sseg2:=0;
              for k:=1 to 4 do
                if (k<>ldir1) and (k<>ldir2) then
                begin
                  a2:=ys1[k]-ys2[k];
                  b2:=xs2[k]-xs1[k];
                  c2:=xs1[k]*ys2[k]-xs2[k]*ys1[k];

                  if abs(a2*b1-a1*b2)>eps then
                    begin
                      xi:=(b2*c1-b1*c2)/(a2*b1-a1*b2);
                      yi:=(c2*a1-c1*a2)/(a2*b1-a1*b2);

                      if (
                         (((xi>=x) and (xi<=xf)) or
                          ((xi>=xf) and (xi<=x))) and
                         (((yi>=y) and (yi<=yf)) or
                          ((yi>=yf) and (yi<=y))) and
                         (((xi>=xs1[k]) and (xi<=xs2[k])) or
                          ((xi>=xs2[k]) and (xi<=xs1[k]))) and
                         (((yi>=ys1[k]) and (yi<=ys2[k])) or
                          ((yi>=ys2[k]) and (yi<=ys1[k])))
                         ) then
                         begin
                           if (sseg1=0) then
                             sseg1:=k
                           else
                             sseg2:=k;

                           xint:=xi; yint:=yi;
                         end;
                    end;
                end;

                    lastl:=i; lastc:=j;

                    case sseg1 of
                    1:begin
                        j:=j-1;
                        ldir1:=2;
                      end;
                    2:begin
                        j:=j+1;
                        ldir1:=1;
                      end;
                    3:begin
                        i:=i+1;
                        ldir1:=4;
                      end;
                    4:begin
                        i:=i-1;
                        ldir1:=3;
                      end;
                    end;

                    case sseg2 of
                    1:begin
                        j:=j-1;
                        ldir2:=2;
                      end;
                    2:begin
                        j:=j+1;
                        ldir2:=1;
                      end;
                    3:begin
                        i:=i+1;
                        ldir2:=4;
                      end;
                    4:begin
                        i:=i-1;
                        ldir2:=3;
                      end;
                    else ldir2:=0;
                    end;

              x:=xint; y:=yint;

              if (a[i,j]>a[lastl,lastc]) then
                solutie:=false;
            end;

          if (solutie) then
            begin
              dmin:=dact;
              lma:=maxl[pma]; cma:=maxc[pma];
              lmi:=minl[pmi]; cmi:=minc[pmi];
            end;
        end;
    end;

if (dmin=infinit) then
  printsol(0)
else
  printsol(1);

end.