program Telescaun;
const DimMax = 100;
      NrMaxPoz = 100 * 100;
      Infinit : Word = MaxInt;
type Indice = 0 .. DimMax;
     Teren = array [Indice, Indice] of word;
     Pozitie = record
               x, y: Indice;
               end;
     Extrem = array [1..NrMaxPoz] of Pozitie;
var c: Teren;
    n, m, i, j: Indice;
    Emax, Emin: Extrem;
    NrMax, NrMin: word;
    LgTraseu, Lg : real;
    Sus, Jos: Pozitie;
    sin: string;

procedure Citire;
var fin: text;
    i, j: Indice;
begin
{write ('fisier intrare '); readln (sin);}
assign (fin, {sin+'.in'} 'cote.in'); reset(fin);
readln (fin, n, m);
for i := 1 to n do
    begin
    for j := 1 to m do
        read (fin, c[i, j]);
    readln (fin);
    end;
close (fin);
end;

function Max: word; {determina cota maxima}
var i, j: Indice; mmax: word;
begin
mmax := c[1, 1];
for i := 1 to n do
    for j := 1 to m do
        if mmax < c[i, j] then mmax := c[i, j];
Max := mmax;
end;

function Min: word; {determina cota minima}
var i, j: Indice;  mmin: word;
begin
mmin := c[1, 1];
for i := 1 to n do
    for j := 1 to m do
        if mmin > c[i, j] then mmin := c[i, j];
Min := mmin;
end;

procedure DetMax; {determina si retine pozitiile cotelor maxime}
var i, j: Indice; mmax: word;
begin
mmax := Max;
for i := 1  to n do
    for j := 1 to m do
        if c[i, j] = mmax then
           begin
           inc (NrMax);
           EMax[NrMax].x:=i;
           Emax[NrMax].y:=j;
           end;
end;

procedure DetMin; {determina si retine pozitiile cotelor minime}
var i, j: Indice; mmin: word;
begin
mmin := Min;
for i := 1  to n do
    for j := 1 to m do
        if c[i, j] = mmin then
           begin
           inc (NrMin);
           EMin[NrMin].x:=i;
           Emin[NrMin].y:=j;
           end;
end;

function dist (c1, c2: Pozitie): real; {distanta dintre punctele c1 si c2}
begin
dist := sqrt (sqr(c1.x-c2.x)+sqr(c1.y-c2.y));
end;

function SePoate (sus, jos: Pozitie): boolean;
{functia principala a programului - verifica daca intre un punct de maxim
SUS, si un punct de minim JOS, exista un traseu descrescator}
var lin, col: Indice;
    dl, dc: real;   {dl - distanta pana la linia urmatoare; dc - ... la coloana}
    cv: word;       {cv - cota veche}
    lr, cr: -1..1;  {deplasari relative pe linie/coloana}
    ok: boolean;
    tg: real;       {tangenta unghiului intre traseu si verticala}

begin
ok := true; cv := c[sus.x, sus.y];
if sus.x > jos.x then lr := -1          {se determina deplasarile relative}
   else if sus.x = jos.x then lr := 0
           else lr := 1;
if sus.y > jos.y then cr := -1
   else if sus.y = jos.y then cr := 0
           else cr := 1;
if lr = 0 then                          {traseu pe linie}
   begin
   col:=sus.y;
   while ok and (col<>jos.y) do
         if c[sus.x,col] > cv then ok := false
            else
            begin
            cv := c[sus.x, col];
            col := col+cr;
            end;
   end;
if cr = 0 then                          {traseu pe coloana}
   begin
   lin:=sus.x;
   while ok and (lin<>jos.x) do
         if c[lin,sus.y] > cv then ok := false
            else
            begin
            cv := c[lin,sus.y];
            lin := lin+lr;
            end;
   end;
if (cr <> 0) and (lr <> 0) then               {traseu oarecare}
   begin
   tg := abs(sus.y-jos.y)/abs(sus.x-jos.x);   {calculam tangenta}
   dl := 0.5; dc:=0.5; lin := sus.x; col := sus.y; {initializari}
   {distanta la linia si coloana urmatoare sunt egale 0.5 deoarece}
   while ok and (lin <> jos.x) do                  {se pleaca din CENTRUL}
         begin                                     {patratelului SUS}
         while (dc >= tg * dl) and (lin <> jos.x) do
               begin   {cat timp nu trece in coloana urmatoare si nu am ajuns}
               lin := lin + lr;              {se trece la linia urmatoare}
               if c[lin, col] > cv then ok := false {cota mai mare - nu se poate}
                  else cv := c[lin, col];    {daca e cota corecta - se retine}
               dl := dl+1;                   {distanta la linie creste cu 1}
               end;
         col := col + cr;              {se trece in coloana urmatoare}
         if (c[lin, col] > cv) and (lin <> jos.x) then ok := false {nu se poate}
            else cv := c[lin, col];         {OK - se retine cota}
         dl := (tg * dl - dc)/tg;  {se recalculeaza distanta la linie}
         dc := 1;                  {distanta la coloana urmatoare devine 1}
         end;
   end;
SePoate := ok;
end;

procedure Afisare;
var fout: text;
begin
assign (fout, {sin+'.out'}'cote.out'); rewrite (fout);
if LgTraseu = Infinit then writeln (fout, 'IMPOSIBIL')
   else
   begin
   writeln (fout, LgTraseu:7:2);
   writeln (fout, Sus.x, ' ',Sus.y,' ', Jos.x,' ', Jos.y);
   end;
close (fout);
end;

begin
Citire;
DetMax;
DetMin;
LgTraseu := Infinit;
for i := 1 to NrMax do    {sunt verificate toate perechile SUS-JOS}
    for j := 1 to NrMin do
        begin
        Lg := dist (Emax[i], Emin[j]);  {distanta pe harta}
        if Lg < LgTraseu then    {daca am gasit un traseu mai scurt}
           if SePoate (Emax[i], Emin[j]) then {si este descrescator  }
              begin                           {retine}
              LgTraseu := Lg;                 {lungimea lui}
              Sus := Emax[i];                 {pozitia SUS - maxim}
              Jos := Emin[j];                 {pozitia JOS - minim}
              end;
        end;
Afisare;
end.
