program Mutant;
uses crt;
const
    MaxNF = 200;
    MaxNP = 60;
    MaxRad = 20;

    MaxNiv = MaxNP;
    MaxCard = 500;
    MaxNT = 500;
    MaxSol = 500;
type
    tipElem=record
        forma: integer;
        rad: integer;
        nivelTata: integer;
        indTata: integer;
    end;
    mul=array[1..MaxCard] of tipElem;
    mulFiuTata= record
       nr: 0..MaxCard;
       elem: ^mul;
    end;
    multime = set of 1..MaxNF;
var
    fo:text;
    { Forme }
    NF: integer;
    F:array[1..MaxNF] of integer;

    { Radiatia pe planete }
    NP: integer;
    R:array[1..MaxNP] of integer;

    { Forme finale }
    M: integer;
    FF: multime;

    { Forma initiala }
    F0: integer;

    { Transformari }
    NT: integer;
    T:array[1..MaxNT] of record
        FC: 1..MaxNF;
        R: integer;
        FU: multime;
    end;

procedure CitesteIn;
var
    fis: text;
    i, j: integer;
begin
    assign(fis, 'mutant.in');
    reset(fis);
    readln(fis, NP);
    read(fis, NF); for i:=1 to NF do read(fis, F[i]);
    readln(fis);
    readln(fis, F0);
    for i:=1 to NP do read(fis, R[i]);
    readln(fis);
    read(fis, M); for i:=1 to M do begin
         read(fis, j);
         FF:=FF+[j];
    end;
    readln(fis);
    NT:=0;
    while not eof(fis) do begin
          NT:=NT+1;
          read(fis, T[NT].FC, T[NT].R);
          T[NT].FU:=[];
          while not seekeoln(fis) do begin
                read(fis, i);
                T[NT].FU := T[NT].FU + [i];
          end;
          readln(fis);
    end;
    close(fis);
end;

var
   raspLor: string;
   nrSol: integer;
   solutie: array[1..MaxSol] of integer;

procedure CitesteOut;
var
    fis: text;
    i, j: integer;
begin
    assign(fis, 'out.dat');
    reset(fis);
    readln(fis, raspLor);
    for i:=1 to 2 do raspLor[i]:=upcase(raspLor[i]);
    nrSol:=0;
    while not eoln(fis) do begin
          nrSol:=nrSol+1;
          read(fis, solutie[nrSol]);
    end;
    readln(fis);
    close(fis);
end;

var
    Multimi : array[1..MaxNiv+1] of mulFiuTata;
    nivel: 1..MaxNiv+1;

procedure Init(nivel: integer);
var
   i: integer;
begin
    new(Multimi[nivel].elem);
    for i:=1 to MaxCard do begin
       Multimi[nivel].elem^[i].forma:=0;
       Multimi[nivel].elem^[i].rad:=-1;
       Multimi[nivel].elem^[i].IndTata:=0;
       Multimi[nivel].elem^[i].nivelTata:=0;
    end;
    if nivel = 1 then begin
       Multimi[nivel].nr:=1;
       Multimi[nivel].elem^[nivel].f                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                function Apartine(nivel, forma, indTata: integer): boolean;
var
   i: integer;
begin
   for i:=1 to Multimi[nivel].nr do
       if (Multimi[nivel].elem^[i].forma = forma) and
          (Multimi[nivel].elem^[i].indTata = indTata) then begin
          Apartine := true;
          exit;
       end;
   Apartine := false;
end;

procedure Adauga(nivel: integer; forme:multime; indTata, rad: integer);
var
   k, f: integer;
begin
   k:=Multimi[nivel].nr;
   for f:=1 to MaxNF do if f in forme then begin
       if not Apartine(nivel, f, indTata) then begin
          k:=k+1;
          Multimi[nivel].elem^[k].forma := f;
          Multimi[nivel].elem^[k].rad := rad;
          Multimi[nivel].elem^[k].indTata := indTata;
          Multimi[nivel].elem^[k].nivelTata := nivel-1;
       end;
   end;
   Multimi[nivel].nr := k;
end;

function Apartine0(nivel, forma: integer): boolean;
var
   i: integer;
begin
   for i:=1 to Multimi[nivel].nr do
       if (Multimi[nivel].elem^[i].forma = forma) then begin
          Apartine0 := true;
          exit;
       end;
   Apartine0 := false;
end;

procedure Adauga0(nivel: integer; forme:multime; indTata: integer; var gata: boolean);
var
   k, f: integer;
begin
   gata:=true;
   k:=Multimi[nivel].nr;
   for f:=1 to MaxNF do if f in forme then begin
       if not Apartine0(nivel, f) then begin
          k:=k+1;
          Multimi[nivel].elem^[k].forma := f;
          Multimi[nivel].elem^[k].rad := 0;
          Multimi[nivel].elem^[k].indTata := indTata;
          Multimi[nivel].elem^[k].nivelTata := nivel;
          gata := false;
       end;
   end;
   Multimi[nivel].nr := k;
end;

procedure TVID(nivel: integer);
var
    fii: multime;
    gata: boolean;
    i: integer;
begin
    repeat
        gata:=true;
        for i:= 1 to Multimi[nivel].nr do begin
            Forme(Multimi[nivel].elem^[i].forma, 0, fii);
            Adauga0(nivel, fii, i, gata);
        end;
    until gata;
end;

function Calcul: boolean;
var
   nivel : 1..MaxNiv;
   i: integer;
   form: multime;
begin
   nivel:=1;
   Init(nivel);
   TVID(nivel);
   for nivel:=1 to NP do begin
       Init(nivel+1);
       for i:=1 to Multimi[nivel].nr do begin
            Forme(Multimi[nivel].elem^[i].forma, R[nivel], form);
            Adauga(nivel+1, form, i, R[nivel]);
       end;
       TVID(nivel+1);
   end
end;

function Disjuncte(nivel: integer; FF: multime): boolean;
var
   i: integer;
begin
   for i:=1 to Multimi[nivel].nr do
       if Multimi[nivel].elem^[i].forma in FF then begin
            Disjuncte := false;
            exit;
       end;
   Disjuncte := true;
end;

procedure Sol(nivel, ind: integer);
begin
    if nivel <> 0 then  begin
         Sol(Multimi[nivel].elem^[ind].nivelTata,
             Multimi[nivel].elem^[ind].indTata);
         if Multimi[nivel].elem^[ind].rad <> -1 then
            write(fo,Multimi[nivel].elem^[ind].rad, ' ');
         write(fo,Multimi[nivel].elem^[ind].forma, ' ');
    end
end;

var raspNos: string;

procedure Rezolva;
var
    niv, i: integer;
begin
    Calcul;
    assign(fo,'mutant.out');
    rewrite(fo);
    if (Disjuncte(NP+1, FF)) then raspNos := 'NU'
    else raspNos:='DA';
    writeln(fo,raspNos);
    for i := 1 to Multimi[NP+1].nr do
        if Multimi[NP+1].elem^[i].forma in FF then begin
           Sol(NP+1, i);
           writeln(fo);
        end;
    close(fo)
end;

var
   NPLor: integer;
   RLor : array[1..MaxNP] of integer;

function TranzBuna(fc, r, fu: integer): boolean;
var i: integer;
begin
     for i:=1 to NT do
        if (T[i].FC = fc) and (T[i].R = r) and (fu in T[i].FU) then begin
            TranzBuna := true;
            if r<> 0 then begin
               inc(NPLor);
               RLor[NPLor]:=r;
            end;
            exit;
        end;
     TranzBuna := false;
end;

function Validare: boolean;
var
   fc, i: integer;
begin
    if (raspLor <> raspNos) then begin
         Validare := false;
         exit;
    end
    else if raspLor = 'DA' then begin
         if solutie[1] <> F0 then begin
             Validare := false;
             exit;
         end;
         fc := solutie[1];
         NPLor := 0;
         i:=2;
         while i < nrSol do begin
             if not TranzBuna(fc, solutie[i], solutie[i+1]) then begin
                Validare := false;
                exit;
             end
             else begin
                fc := solutie[i+1];
                i:=i+2;
             end
         end;
         if not (solutie[nrSol] in FF) then begin
             Validare := false;
             exit;
         end;
         if NP <> NPLor then begin
             Validare := false;
             exit;
         end;
         for i:=1 to NP do
            if R[i] <> RLor[i] then begin
               Validare := false;
               exit;
            end
    end
    else if raspLor = 'NU' then begin
         if nrSol <> 0 then  begin
             Validare := false;
             exit;
         end
    end;
    Validare := true;
end;

var i: integer;

begin
     clrscr;
     CitesteIn;
{     writeln('Solutie corecta');}
     Rezolva;

    { CitesteOut;
     writeln('Solutie concurent');
     writeln(raspLor);
     for i:=1 to nrSol do write(solutie[i], ' ');
     writeln;

     if Validare then writeln('Rezolvare corecta')
     else write('Rezolvare incorecta');
     readln;}
end.