#include <stdio.h>
#include <stdlib.h>

#define MAX 55

int x[MAX];
int y[MAX];
int x1[MAX];
int y1[MAX];
int n;

void citeste();
void prelafis();


int main()
{
	citeste();
	prelafis();
	return 0;
}

void citeste()
{
	int i;
	FILE * f;

	if(!(f=fopen("POLIGON.IN","r"))){
		printf("Sorry... No can open input file...\n");
		exit(1);
	}
	fscanf(f,"%d",&n);

	for(i=0;i<n;i++)
		fscanf(f,"%d %d",x+i,y+i);

	fclose(f);
}

void prelafis()
{
	int i,j;
	int este;
	int sx,sy;
	int p2;
	int sav;
	int dx,dy;

	FILE * f;

	if(!(f=fopen("POLIGON.OUT","w"))){
		printf("Sorry... No can open output file...\n");
		exit(2);
	}
	p2=n/2;
	if(n & 1){
			/* hehe... un pol. cu nr impar de vf. nu poate avea
			 * centru de simetrie... */
		fprintf(f,"NU\n");
		fclose(f);
		return;
	}
	sx=x[0]+x[p2];
	sy=y[0]+y[p2];
	este=1;
	for(i=0;i<p2;i++){
		este = este
			 &&(sx==(x[i]+x[i+p2]))
			 &&(sy==(y[i]+y[i+p2]));
	}
	if(!este){
		fprintf(f,"NU\n");
		fclose(f);
		return;
	}
	fprintf(f,"DA\n");
	/* daca este... hai sa-l compactam...
	 * nu-mi plac laturile in prelungire...
	 */
	if((x[0]-x[1])*(y[n-1]-y[0])==(y[0]-y[1])*(y[n-1]-y[0])){
		/*suxx... nu imi plac laturile continue la vf. 0... */
		for(i=0;
			  (x[i]-x[i+1])*(y[i+1]-y[i+2])
			==(y[i]-y[i+1])*(x[i+1]-x[i+2])
		;i++);
		/* i,i+1,i+2 nu sunt coliniare... incepem de la i+1 */
		sav=i+1;
		for(i=0;i<n;i++){
			x1[i]=x[(i+sav)%n];
			y1[i]=y[(i+sav)%n];
		}
		for(i=0;i<n;i++)
			x[i]=x1[i],y[i]=y1[i];
	}
	/* vf 0 nu e pe o latura... pe celelalte le compactam... */
	j=0;
	x[n]=x[0];
	y[n]=y[0];
	for(i=1;i<n;i++){
		if(
		((x[j]-x[i])*(y[j]-y[i+1])!=(y[j]-y[i])*(x[j]-x[i+1]))
		){
			j++;
			x[j]=x[i];
			y[j]=y[i];
		}
	}
	/* gata  compact.... */
	n=j+1;
	p2=n>>1;
	sav=p2;
	for(i=1;i<sav;i++){
		dx=x[0]-x[1];
		dy=y[0]-y[1];
		for(j=0;j<p2-1;j++){
			fprintf(f,"%d %d %d %d %d %d %d %d\n",
				x[1+j],y[1+j],x[2+j],y[2+j],
				x[2+j]+dx,y[2+j]+dy,x[1+j]+dx,y[1+j]+dy);
		}

		for(j=0;j<=p2;j++){
			x[j]=x[j+1]+dx;
			y[j]=y[j+1]+dy;
		}
		for(j=0;j<p2;j++){
			x[j+p2]=x[j+p2+2];
			y[j+p2]=y[j+p2+2];
		}
		n-=2;
		p2--;

	}


	fclose(f);

}


